# TRELLIS.2 LoRA Inference API

> ဖွဲ့စည်းပုံ၊ ဂျီဩမေတြီနှင့် မျက်နှာပြင်အသားပေးအတွက် စိတ်ကြိုက် LoRA adapter များကို အသုံးပြုနိုင်သည့် Trellis 2 image-to-3D

`image_url` မှ GLB တစ်ခုကို ဖန်တီးပြီး `sparse_structure_lora_url`၊ `geometry_lora_url` နှင့် `texture_lora_url` တို့မှတစ်ဆင့် safetensors LoRA များကို ရွေးချယ်အသုံးပြုနိုင်သည်။ `resolution` သည် 512 သို့မဟုတ် 1024 ဖြစ်ပြီး adapter များ၏ လေ့ကျင့်ရေး ရုပ်ထွက်အရည်အသွေးနှင့် ကိုက်ညီရမည်။ အဆင့်တစ်ခုချင်းစီအတွက် လမ်းညွှန်မှုနှင့် အဆင့် ထိန်းချုပ်ချက်များ၊ `decimation_target` နှင့် `texture_size` တို့လည်း ပါဝင်သည်။

- Model id: `trellis-2-lora`
- Made by: Microsoft
- Category: Image to 3D
- Output: 3d
- Price: from $0.25 / request (cheapest run $0.25 (250 API credits))
- Run: `POST https://api.doitong.com/v1/run/trellis-2-lora`
- Quote: `POST https://api.doitong.com/v1/quote/trellis-2-lora`
- Docs page: https://doitong.com/my/developers/models/trellis-2-lora

## Pricing

Price: **from $0.25 / request** (the lowest tier; the quote prices your exact input). Billed once per request.

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `resolution` = 1024: $0.30 (300 API credits) / request

The full example input below costs $0.25 = 250 API credits (1 request × 250 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/trellis-2-lora` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `image_url` | `image` | string (image URL) | yes |  |  | 3D မော်ဒယ်အဖြစ် ပြောင်းရန် မူလပုံ URL။ |
| `sparse_structure_lora_url` |  | string \| null | no |  |  | sparse structure denoiser အတွက် သီးသန့်လေ့ကျင့်ထားသော safetensors ဖော်မတ်ရှိ ရွေးချယ်နိုင်သော LoRA checkpoint။ |
| `geometry_lora_url` |  | string \| null | no |  |  | geometry denoiser အတွက် သီးသန့်လေ့ကျင့်ထားသော safetensors ဖော်မတ်ရှိ ရွေးချယ်နိုင်သော LoRA checkpoint။ |
| `texture_lora_url` |  | string \| null | no |  |  | texture denoiser အတွက် သီးသန့်လေ့ကျင့်ထားသော safetensors ဖော်မတ်ရှိ ရွေးချယ်နိုင်သော LoRA checkpoint။ |
| `seed` |  | integer \| null | no |  |  | ဖန်တီးမှုကို ထပ်တူပြန်လုပ်နိုင်စေသော ကျပန်း seed။ |
| `resolution` |  | enum (integer) | no | `512` | `512`, `1024` | ဖန်တီးမှု ရုပ်ထွက်အရည်အသွေး။ 1024 ကို ရွေးချယ်ပါက cascade pipeline ကို အသုံးပြုသည်။ ပေးထားသော LoRA adapter များကို လေ့ကျင့်ထားသည့် ရုပ်ထွက်အရည်အသွေးကို ရွေးချယ်ရမည်ဖြစ်ပြီး တူညီရန် လိုအပ်သည်။ |
| `ss_guidance_strength` |  | number | no | `7.5` | 0 – 10 | sparse-structure ဖန်တီးမှုအတွင်း classifier-free guidance ၏ အင်အား။ |
| `ss_guidance_rescale` |  | number | no | `0.7` | 0 – 1 | sparse-structure ဖန်တီးမှုအတွင်း guidance rescaling။ တန်ဖိုးကြီးလေ ထွက်ရလဒ် ပိုမိုတည်ငြိမ်လေ ဖြစ်သည်။ |
| `ss_guidance_interval_start` |  | number | no | `0.6` | 0 – 1 | sparse-structure guidance စတင်သည့် denoising တိုးတက်မှု၏ အချိုးအစား။ |
| `ss_guidance_interval_end` |  | number | no | `1` | 0 – 1 | sparse-structure guidance ရပ်တန့်မည့်အချိန်ကို သတ်မှတ်ရန် `ss_guidance_interval_start` နှင့် တူညီသော သို့မဟုတ် ပိုမြင့်သော denoising အချိုးအစားကို အသုံးပြုသည်။ |
| `ss_sampling_steps` |  | integer | no | `12` | 1 – 50 | sparse-structure ဖန်တီးမှုအတွင်း အသုံးပြုသည့် denoising အဆင့်အရေအတွက်။ |
| `ss_rescale_t` |  | number | no | `5` | 1 – 6 | sparse-structure ဖန်တီးမှုအတွင်း noise schedule ၏ ပြတ်သားမှု။ |
| `shape_slat_guidance_strength` |  | number | no | `7.5` | 0 – 10 | shape ဖန်တီးမှုအတွင်း classifier-free guidance ၏ အင်အား။ |
| `shape_slat_guidance_rescale` |  | number | no | `0.5` | 0 – 1 | shape ဖန်တီးမှုအတွင်း guidance တွင် အသုံးပြုသော rescaling။ geometry တွင် noise များပါက တန်ဖိုးကို မြှင့်ပါ။ |
| `shape_slat_guidance_interval_start` |  | number | no | `0.6` | 0 – 1 | shape-stage guidance စတင်သည့် denoising အချိုးအစား။ |
| `shape_slat_guidance_interval_end` |  | number | no | `1` | 0 – 1 | shape-stage guidance ရပ်တန့်မည့်နေရာ။ shape_slat_guidance_interval_start ထက် မနိမ့်သော denoising အချိုးအစားဖြင့် ဖော်ပြသည်။ |
| `shape_slat_sampling_steps` |  | integer | no | `12` | 1 – 50 | shape ဖန်တီးမှုအတွင်း denoising အဆင့်အရေအတွက်။ |
| `shape_slat_rescale_t` |  | number | no | `3` | 1 – 6 | shape ဖန်တီးမှုအတွင်း noise schedule ၏ ပြတ်သားမှု။ |
| `tex_slat_guidance_strength` |  | number | no | `1` | 0 – 10 | texture ဖန်တီးမှုအတွင်း classifier-free guidance ၏ အင်အား။ |
| `tex_slat_guidance_rescale` |  | number | no | `0` | 0 – 1 | texture ဖန်တီးမှုအတွင်း guidance တွင် အသုံးပြုသော rescaling။ texture တွင် noise များပါက တန်ဖိုးကို မြှင့်ပါ။ |
| `tex_slat_guidance_interval_start` |  | number | no | `0.6` | 0 – 1 | texture-stage guidance စတင်သည့် denoising အချိုးအစား။ |
| `tex_slat_guidance_interval_end` |  | number | no | `0.9` | 0 – 1 | texture-stage guidance ရပ်တန့်မည့်နေရာ။ tex_slat_guidance_interval_start ထက် မနိမ့်သော denoising အချိုးအစားဖြင့် ဖော်ပြသည်။ |
| `tex_slat_sampling_steps` |  | integer | no | `12` | 1 – 50 | texture ဖန်တီးမှုအတွင်း denoising အဆင့်အရေအတွက်။ |
| `tex_slat_rescale_t` |  | number | no | `3` | 1 – 6 | texture ဖန်တီးမှုအတွင်း noise schedule ၏ ပြတ်သားမှု။ |
| `decimation_target` |  | integer | no | `500000` | 5,000 – 2,000,000 | GLB export တွင် လိုချင်သော vertex အရေအတွက်။ |
| `texture_size` |  | enum (integer) | no | `2048` | `1024`, `2048`, `4096` | GLB export တွင် ထည့်သွင်းထားသော texture များ၏ ရုပ်ထွက်အရည်အသွေး။ |
| `enable_safety_checker` |  | boolean | no | `true` |  | caller က ခွင့်ပြုချက်ရှိပါက false သတ်မှတ်ခြင်းဖြင့် စစ်ဆေးမှုကို လျှော့ချနိုင်သည်။ |

File parameters (`image`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "image": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

A fuller example:

```json
{
  "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/trellis-2-lora?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/trellis-2-lora?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/trellis-2-lora", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "trellis-2-lora",
      "input": {
        "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "trellis-2-lora",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 250,
    "usd": "0.25",
    "charged": 250,
    "refunded": 0
  },
  "input": {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  },
  "output": {
    "model_glb": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "seed": 42,
    "resolution": 1,
    "sparse_structure_lora_url": "string",
    "geometry_lora_url": "string",
    "texture_lora_url": "string",
    "decimation_target": 1,
    "texture_size": 1
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `model_glb` | object {url, content_type, file_name, file_size} | ဖန်တီးထားသော 3D မော်ဒယ်ပါဝင်သည့် GLB ဖိုင်။ |
| `seed` | integer | ဖန်တီးစဉ် အသုံးပြုထားသော seed။ |
| `resolution` | integer | ဖန်တီးမှု ပြုလုပ်ခဲ့သည့် ရုပ်ထွက်အရည်အသွေး။ |
| `sparse_structure_lora_url` | string \| null | ဖန်တီးမှုအတွင်း အသုံးပြုခဲ့သော sparse-structure LoRA checkpoint (အသုံးပြုထားပါက)။ |
| `geometry_lora_url` | string \| null | ဖန်တီးမှုအတွင်း အသုံးပြုခဲ့သော geometry LoRA checkpoint (အသုံးပြုထားပါက)။ |
| `texture_lora_url` | string \| null | ဖန်တီးမှုအတွင်း အသုံးပြုခဲ့သော texture LoRA checkpoint (အသုံးပြုထားပါက)။ |
| `decimation_target` | integer | GLB export တွင် အသုံးပြုထားသော vertex အရေအတွက် ရည်မှန်းချက်။ |
| `texture_size` | integer | GLB export တွင် ထည့်သွင်းထားသော texture များ၏ ရုပ်ထွက်အရည်အသွေး။ |

## Related models

- [Trellis](https://doitong.com/developers/models/trellis.md) (`trellis`): $0.02 / request
- [Trellis 2](https://doitong.com/developers/models/trellis-2.md) (`trellis-2`): from $0.25 / request
- [Trellis 2 · Retexture](https://doitong.com/developers/models/trellis-2/retexture.md) (`trellis-2/retexture`): from $0.20 / request
- [Trellis · Multi](https://doitong.com/developers/models/trellis/multi.md) (`trellis/multi`): $0.02 / request
- [Hi3D Image to 3D](https://doitong.com/developers/models/hitem3d/hi3d/image-to-3d.md) (`hitem3d/hi3d/image-to-3d`): $0.50 / run
- [Hi3D Image to 3D · v3.0](https://doitong.com/developers/models/hitem3d/hi3d/v3.0/image-to-3d.md) (`hitem3d/hi3d/v3.0/image-to-3d`): from $1.80 / run
- [Hi3D Multiview to 3D · Multi View to 3D](https://doitong.com/developers/models/hitem3d/hi3d/multi-view-to-3d.md) (`hitem3d/hi3d/multi-view-to-3d`): $0.50 / run
- [Hi3D Multiview to 3D · v3.0 · Multi View to 3D](https://doitong.com/developers/models/hitem3d/hi3d/v3.0/multi-view-to-3d.md) (`hitem3d/hi3d/v3.0/multi-view-to-3d`): from $1.80 / run

## Links

- HTML page: https://doitong.com/developers/models/trellis-2-lora
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=trellis-2-lora
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/trellis-2-lora
